RTEMS: Classic Message Queue Implementation

| RTEMS 5.4-rc2

Loading...
Searching...
No Matches
Files | Data Structures | Macros | Enumerations | Functions | Variables
Classic Message Queue Implementation
Internal » Classic

## Files
file | messageimpl.h
| Classic Message Queue Manager Implementation.

## Data Structures
struct | Message_queue_Control

## Macros
#define | MESSAGE_QUEUE_INFORMATION_DEFINE(max)
| Macro to define the objects information for the Classic Message Queue objects.

## Enumerations
enum | Message_queue_Submit_types { MESSAGE_QUEUE_SEND_REQUEST = 0 , MESSAGE_QUEUE_URGENT_REQUEST = 1 }

## Functions
rtems_status_code | _Message_queue_Submit (rtems_id id, const void *buffer, size_t size, Message_queue_Submit_types submit_type)
| Message_queue_Submit.
RTEMS_INLINE_ROUTINE void | _Message_queue_Free (Message_queue_Control *the_message_queue)
| Deallocates a message queue control block into the inactive chain of free message queue control blocks.
RTEMS_INLINE_ROUTINE Message_queue_Control * | _Message_queue_Get (Objects_Id id, Thread_queue_Context *queue_context)
RTEMS_INLINE_ROUTINE Message_queue_Control * | _Message_queue_Allocate (void)

## Variables
Objects_Information | _Message_queue_Information
| The Classic Message Queue objects information.

## Detailed Description

## Macro Definition Documentation

## ◆ MESSAGE_QUEUE_INFORMATION_DEFINE

#define MESSAGE_QUEUE_INFORMATION_DEFINE | ( |  | max | ) |

Value:
OBJECTS_INFORMATION_DEFINE( \
_Message_queue, \
OBJECTS_CLASSIC_API, \
OBJECTS_RTEMS_MESSAGE_QUEUES, \
Message_queue_Control, \
max, \
OBJECTS_NO_STRING_NAME, \
_Message_queue_MP_Send_extract_proxy \
)
OBJECTS_NO_STRING_NAME
#define OBJECTS_NO_STRING_NAME
Constant for the object information string name length to indicate that this object class has no stri...
Definition: objectdata.h:101
OBJECTS_INFORMATION_DEFINE
#define OBJECTS_INFORMATION_DEFINE(name, api, cls, type, max, nl, ex)
Statically initializes an objects information.
Definition: objectdata.h:427
Message_queue_Control
Definition: messagedata.h:38

Macro to define the objects information for the Classic Message Queue objects.

This macro should only be used by <rtems/confdefs.h>.

Parameters

  max | The configured object maximum (the OBJECTS_UNLIMITED_OBJECTS flag may be set).

## Enumeration Type Documentation

## ◆ Message_queue_Submit_types

enum Message_queue_Submit_types

The following enumerated type details the modes in which a message may be submitted to a message queue. The message may be posted in a send or urgent fashion.

Enumerator
MESSAGE_QUEUE_SEND_REQUEST | This value indicates the user wants to send the message using the normal message insertion protocol (FIFO or priority).
MESSAGE_QUEUE_URGENT_REQUEST | This value indicates the user considers the message to be urgent and wants it inserted at the head of the pending message queue.

## Function Documentation

## ◆ _Message_queue_Free()

RTEMS_INLINE_ROUTINE void _Message_queue_Free | ( | Message_queue_Control * | the_message_queue | ) |

Deallocates a message queue control block into the inactive chain of free message queue control blocks.

This routine deallocates a message queue control block into the inactive chain of free message queue control blocks.

## ◆ _Message_queue_Submit()

rtems_status_code _Message_queue_Submit | ( | rtems_id | id,
|  | const void * | buffer,
|  | size_t | size,
|  | Message_queue_Submit_types | submit_type
| ) |  |

Message_queue_Submit.

This routine implements the directives rtems_message_queue_send and rtems_message_queue_urgent. It processes a message that is to be submitted to the designated message queue. The message will either be processed as a send send message which it will be inserted at the rear of the queue or it will be processed as an urgent message which will be inserted at the front of the queue.